Lattice Grid Buy a licence

demo D134

Type a page to jump to it

The pager interaction, not the paged source

pagination

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.min.css">

<div id="grid"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/modules/react.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  const columns = [
    { field: 'service', title: 'Service', layout: { pin: 'start', width: 140 } },
    { field: 'team', title: 'Team', filter: { type: 'set' } },
    { field: 'owner', title: 'Owner', filter: { type: 'set' } },
    { field: 'tier', title: 'Tier', cell: { decoration: 'pill', variant: { map: { gold: 'warning', silver: 'neutral', bronze: 'info' } } } },
    { field: 'state', title: 'State', cell: { decoration: 'dot', variant: { map: { healthy: 'success', degraded: 'warning', failing: 'danger', unknown: 'neutral' } } } },
    { field: 'region', title: 'Region', filter: { type: 'set' } },
    { field: 'active', title: 'Active', type: 'boolean' },
    { field: 'deprecated', title: 'Deprecated', type: 'boolean' },
  ];

  const rows = [/* 20,000 service records: 25 to a page is 800 pages */];

  function App() {
    return (
      <LatticeGrid
        rowKey="id"
        pagination={{ enabled: true, pageSize: 25, pageSizes: [25, 50, 100] }}
        columns={columns}
        rows={rows}
        style={{ height: '540px' }}
      />
    );
  }

  createRoot(document.getElementById('grid')).render(<App />);
</script>

Jumping straight to a page number in the pager

Paging through a result set one click at a time is fine for the first few pages and tedious past that, so a JavaScript data grid with a built-in pager benefits from a direct entry point: a field where a user types a page number and lands on it, rather than clicking “next” repeatedly. Lattice Grid exposes this through the pagination option, which configures the pager’s page size, current page, and the controls it renders, including the jump-to-page input alongside the previous/next and first/last buttons. The pager is a chrome element, independent of how rows are sourced, whether that is an in-memory array or a server-side row model returning one page per request.

Typing a page number and pressing return validates it against the known page count, clamping out-of-range entries rather than requesting a page that does not exist. The input carries an aria-label identifying it as a page number field, and the pager is a navigation region so assistive technology announces the current page and total. For a server-backed source, jumping to a distant page issues a single fetch for that page’s rows, so a jump from page 2 to page 400 costs the same as a jump to page 3.

How do you let users type a page number instead of clicking through a pager?

Configure the pagination option and enable the jump-to-page input in the pager controls. Lattice Grid renders a numeric field next to the standard next/previous buttons; entering a number and confirming it moves the grid directly to that page, with out-of-range values clamped to the nearest valid page rather than rejected outright.

Lattice Grid Buy a licence

demo D134

Type a page to jump to it

The pager interaction, not the paged source

pagination

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

const columns = [
  { field: 'service', title: 'Service', layout: { pin: 'start', width: 140 } },
  { field: 'team', title: 'Team', filter: { type: 'set' } },
  { field: 'owner', title: 'Owner', filter: { type: 'set' } },
  { field: 'tier', title: 'Tier', cell: { decoration: 'pill', variant: { map: { gold: 'warning', silver: 'neutral', bronze: 'info' } } } },
  { field: 'state', title: 'State', cell: { decoration: 'dot', variant: { map: { healthy: 'success', degraded: 'warning', failing: 'danger', unknown: 'neutral' } } } },
  { field: 'region', title: 'Region', filter: { type: 'set' } },
  { field: 'active', title: 'Active', type: 'boolean' },
  { field: 'deprecated', title: 'Deprecated', type: 'boolean' },
];

const rows = [/* 20,000 service records: 25 to a page is 800 pages */];



@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template: '<lattice-grid [config]="grid" style="display:block;height:540px"></lattice-grid>',
})
export class AppComponent {
  grid = {
    rowKey: 'id',
    pagination: { enabled: true, pageSize: 25, pageSizes: [25, 50, 100] },
    columns: columns,
    rows: rows,
  };
}

bootstrapApplication(AppComponent);

Jumping straight to a page number in the pager

Paging through a result set one click at a time is fine for the first few pages and tedious past that, so a JavaScript data grid with a built-in pager benefits from a direct entry point: a field where a user types a page number and lands on it, rather than clicking “next” repeatedly. Lattice Grid exposes this through the pagination option, which configures the pager’s page size, current page, and the controls it renders, including the jump-to-page input alongside the previous/next and first/last buttons. The pager is a chrome element, independent of how rows are sourced, whether that is an in-memory array or a server-side row model returning one page per request.

Typing a page number and pressing return validates it against the known page count, clamping out-of-range entries rather than requesting a page that does not exist. The input carries an aria-label identifying it as a page number field, and the pager is a navigation region so assistive technology announces the current page and total. For a server-backed source, jumping to a distant page issues a single fetch for that page’s rows, so a jump from page 2 to page 400 costs the same as a jump to page 3.

How do you let users type a page number instead of clicking through a pager?

Configure the pagination option and enable the jump-to-page input in the pager controls. Lattice Grid renders a numeric field next to the standard next/previous buttons; entering a number and confirming it moves the grid directly to that page, with out-of-range values clamped to the nearest valid page rather than rejected outright.